*+
*+
*+    Source Module => d:\ALASKA\LCD_UHR\DLG8LCD.PRG
*+
*+    Functions: Procedure APPSYS()
*+               Procedure MAIN()
*+               Class DLG8LCD
*+               Method DLG8LCD:init()
*+               Method DLG8LCD:create()
*+               Method DLG8LCD:Destroy()
*+               Method DLG8LCD:API_SetRegion()
*+               Method DLG8LCD:ShowZero()
*+               Method DLG8LCD:ShowTime()
*+               Method DLG8LCD:LoadMask()
*+               Method DLG8LCD:GetMaskArray()
*+               Method DLG8LCD:MaskItemArray()
*+               Method DLG8LCD:ZahlArray()
*+               Method DLG8LCD:MakeMenu()
*+               Method DLG8LCD:MenuZoom()
*+               Method DLG8LCD:MenuTPZ()
*+               Method DLG8LCD:SetTPZ()
*+               Class ResourceAsBmp
*+               Method ResourceAsBmp:Load()
*+               Static Function BMP2BMP()
*+               Static Function BMPsplit()
*+               Static Function MoveNow()
*+               Static Function MoveWin()
*+               Static Function GetCursorPos()
*+               Static Function GetaPosAndSize()
*+               Static Function PopAbsPos()
*+               Function SetWindowLayered()
*+               Function SetWindowTransparency()
*+               Function GetWindowLongA()
*+               Function SetWindowLongA()
*+               Function SetLayeredWindowAttributes()
*+
*+    Reformatted by Click! 2.03a on Okt-17-2018 at  7:14 am
*+
*+

#INCLUDE "XBP.CH"
#INCLUDE "APPEVENT.CH"
#INCLUDE "DLL.CH"
#INCLUDE "COMMON.CH"
#INCLUDE "GRA.CH"

#define RGN_OR 2
#define LWA_ALPHA             0x2


#IFDEF __XPP__
   #define GWL_EXSTYLE           -20
   #define WS_EX_LAYERED         0x80000
   #define WS_EX_APPWINDOW       0x00040000

   #xtranslate SetDefault(<var>, <def>) => iif(<var>==NIL, <var>:=<def>, <var>)

#ELSE

   #define IDD_DIALOG1                        1
   #define IDC_BUTTON1                        999

   #include "HBXBASE.CH"

   #include "wvtwin.ch"
   #include "hbgtinfo.ch"
   #include "hbgtwvg.ch"
   #include "wvgparts.ch"

   #xcommand METHOD <!ClassName!>:<MethodName> => METHOD <MethodName> CLASS <ClassName>

#ENDIF

#IFDEF __XPP__
PROCEDURE APPSYS
   LOCAL cTitle  := "DLG8LCD"
   LOCAL hWndDlg := DllCall( "User32.dll", DLL_STDCALL, "FindWindowA", 0, cTitle )
   IF !( hWndDlg == 0 )
      DllCall( "User32.dll", DLL_STDCALL, "SetForegroundWindow", hWndDlg )
      DllCall( "User32.dll", DLL_STDCALL, "BringWindowToTop", hWndDlg )
      DllCall( "User32.dll", DLL_STDCALL, "ShowWindow", hWndDlg, 1 )
      DllCall( "User32.dll", DLL_STDCALL, "UpdateWindow", hWndDlg )
      QUIT                                                  // It is a second instance. Bye Bye
   ENDIF
   RETURN
#ELSE
Function HB_GTSYS()
   REQUEST HB_GT_WVG_DEFAULT
   REQUEST HB_GT_WVT
   REQUEST HB_GT_WGU
   Return NIL
#ENDIF

*+
*+
*+    Procedure MAIN()
*+
*+
*+
PROCEDURE MAIN()

LOCAL nEvent, mp1, mp2, oXbp
LOCAL oDlg, cFile
LOCAL aDesk  := APPDESKTOP() :CurrentSize()
LOCAL i, iMax := PCOUNT()

   oDlg := DLG8LCD() :new()
   IF iMax > 0
      FOR i := 1 TO iMax
         cFile := PVALUE( 1 )
         IF FILE( cFile )
            oDlg:cLogo = cFile
         ELSEIF VAL( cFile ) > 0
            oDlg:nLogo = VAL( cFile )
         ENDIF
      NEXT
   ENDIF

#IFDEF __XPP__
*  AEVAL( oDlg:aAnzeig, { | o | o:Close := { || PostAppEvent( xbeP_Close,,, GetApplication() :mainForm ) } } )
#ELSE
   AEVAL( oDlg:aAnzeig, { | o | o:Close := { || PostAppEvent( xbeP_Close,,, oDlg ) } } )
#ENDIF

   oDlg:create()

   // Thread every Second
   SetTimerEvent( 100, { || oDlg:ShowTime() } )

   SETAPPFOCUS( oDlg:aAnzeig[ 1 ] )

   nEvent := xbe_None
   DO WHILE nEvent <> xbeP_Close
      nEvent := APPEVENT( @mp1, @mp2, @oXbp )
      DO CASE
         CASE nEvent == xbeP_Keyboard .AND. mp1 == xbeK_ESC
            EXIT
         CASE nEvent == xbeP_Keyboard .AND. mp1 == xbeK_ALT_F4
            EXIT

         CASE nEvent == xbeM_LbDown
            MoveNow( oDlg:aAnzeig[ 1 ] )

         CASE nEvent == xbeM_RbDown
            oDlg:oMenu:popUp( oDlg:aAnzeig[ 1 ], PopAbsPos( oDlg:aAnzeig[ 1 ] ) )
      ENDCASE
      oXbp:HandleEvent( nEvent, mp1, mp2 )
   ENDDO

   SetTimerEvent( 0 )
   oDlg:Destroy()
   QUIT

RETURN

* -------------------------------------------------------------------------- *

*+
*+
*+    Class DLG8LCD
*+
*+
*+
CLASS DLG8LCD

   EXPORTED:
      VAR oH1                                               // Dialog (Master)
      VAR oH2                                               // Dialog
      VAR oP1                                               // Dialog
      VAR oM1                                               // Dialog
      VAR oM2                                               // Dialog
      VAR oP2                                               // Dialog
      VAR oS1                                               // Dialog
      VAR oS2                                               // Dialog

      VAR aTime                                            // Time Cache
      VAR aAnzeig                                           // Array Dialog
      VAR aMask                                             // Array Mask
      VAR oBMP                                              // _Internal_  Image for each Dialog
      VAR cLogo                                             // User assign Image for each Dialog
      VAR nLogo                                             // Resource as default Image
      VAR aDlgSize                                          // Size of Dialog (Init -> Create)
      VAR nXzoom                                            // X Zoom Factor
      VAR nYzoom                                            // Y Zoom Factor
      VAR oMenu                                             // Zoom Menu
      VAR nDLL1                                             // Handle DLL 'GDI32.DLL'
      VAR nDll2                                             // Handle DLL 'USER32.DLL'

      METHOD INIT()
      METHOD create()
      METHOD Destroy()
      METHOD ShowTime()                                     // show Time
      METHOD LoadMask()                                     // load Mask
      METHOD MaskItemArray()                                // Array of Mask
      METHOD GetMaskArray()                                 // get Array
      METHOD ZahlArray()                                    // Array Choise
      METHOD MakeMenu()                                     // Pop-Up Menu
      METHOD MenuZoom()                                     // Menu Zoom
      METHOD MenuTPZ()                                      // Menu Transparency
      METHOD SetTPZ()                                       // Set Transparency

      METHOD ShowZero()                                     // Zoom : new Calc
      METHOD API_SetRegion()

ENDCLASS

*+
*+
*+    Method DLG8LCD:init()
*+
*+
*+
METHOD DLG8LCD:init()

LOCAL aDesk  := APPDESKTOP() :CurrentSize()
LOCAL aPos   := { 0, 0 }
LOCAL aSize  := { 100, 300 }
LOCAL oOwner
LOCAL aPres

* #define Use_TOPLEFT
#IFDEF Use_TOPLEFT
   aPres := { { XBP_PP_ORIGIN, XBP_ORIGIN_TOPLEFT } }
#ELSE
   aPres := { { XBP_PP_ORIGIN, XBP_ORIGIN_BOTTOMLEFT } }
#ENDIF

   ::nLogo := 999
#IFDEF __XPP__
   ::oBMP := ResourceAsBmp() :new() :create()               // BMP, JPG, PNG, GIF
   ::oBMP:Load(, ::nLogo )
#ELSE
   ::oBMP := XBPBITMAP() :New() :Create()
   ::oBMP:Loadfile( "COLORS.BMP" )
#ENDIF

   ::aTime   := { "", "", "", "", "", "", "", "" }

   ::nXzoom := 1.0
   ::nYzoom := 1.0

   aSize[ 1 ] *= ::nXzoom
   aSize[ 2 ] *= ::nYzoom
   ::aDlgSize := ACLONE( aSize )

   aPos[ 1 ] := ( aDesk[ 1 ] - ( 8 * aSize[ 1 ] ) - 8 ) / 2
   aPos[ 2 ] := ( aDesk[ 2 ] - aSize[ 2 ] ) / 2

   ::oH1 := XBPDIALOG() :new( APPDESKTOP(),, aPos,, aPres, .F. )

   oOwner := ::oH1
   aPos[ 1 ] += aSize[ 1 ] + 2
   ::oH2 := XBPDIALOG() :new( APPDESKTOP(), oOwner, aPos,, aPres, .F. )

   oOwner := ::oH2
   aPos[ 1 ] += aSize[ 1 ] + 2
   ::oP1 := XBPDIALOG() :new( APPDESKTOP(), oOwner, aPos,, aPres, .F. )

   oOwner := ::oP1
   aPos[ 1 ] += aSize[ 1 ] + 2
   ::oM1 := XBPDIALOG() :new( APPDESKTOP(), oOwner, aPos,, aPres, .F. )

   oOwner := ::oM1
   aPos[ 1 ] += aSize[ 1 ] + 2
   ::oM2 := XBPDIALOG() :new( APPDESKTOP(), oOwner, aPos,, aPres, .F. )

   oOwner := ::oM2
   aPos[ 1 ] += aSize[ 1 ] + 2
   ::oP2 := XBPDIALOG() :new( APPDESKTOP(), oOwner, aPos,, aPres, .F. )

   oOwner := ::oP2
   aPos[ 1 ] += aSize[ 1 ] + 2
   ::oS1 := XBPDIALOG() :new( APPDESKTOP(), oOwner, aPos,, aPres, .F. )

   oOwner := ::oS1
   aPos[ 1 ] += aSize[ 1 ] + 2
   ::oS2 := XBPDIALOG() :new( APPDESKTOP(), oOwner, aPos,, aPres, .F. )

   ::aAnzeig := {}

   AADD( ::aAnzeig, ::oH1 )
   AADD( ::aAnzeig, ::oH2 )
   AADD( ::aAnzeig, ::oP1 )
   AADD( ::aAnzeig, ::oM1 )
   AADD( ::aAnzeig, ::oM2 )
   AADD( ::aAnzeig, ::oP2 )
   AADD( ::aAnzeig, ::oS1 )
   AADD( ::aAnzeig, ::oS2 )

   AEVAL( ::aAnzeig, { | o | o:Icon := 1 } )
#IFDEF __XPP__
   AEVAL( ::aAnzeig, { | o | o:titlebar := .F. } )
   AEVAL( ::aAnzeig, { | o | o:border := XBPDLG_NO_BORDER } )
   * AEVAL( ::aAnzeig, { | o | o:Origin := XBPDLG_ORIGIN_SCREEN } )
   AEVAL( ::aAnzeig, { | o | o:Clientsize := aSize } )
#ENDIF
   * AEVAL( ::aAnzeig, { | o | o:MaxSize := aSize } )
   * AEVAL( ::aAnzeig, { | o | o:MinSize := aSize } )
   AEVAL( ::aAnzeig, { | o | o:clipSiblings := .T. } )
   AEVAL( ::aAnzeig, { | o, i | IF( i = 1, o:Tasklist := .T., o:Tasklist := .F. ) } )

   ::aAnzeig[ 1 ] :title := "DLG8LCD"

   ::aMask := ::LoadMask()

   ::nDLL1 := DllLoad( 'GDI32.DLL' )
   ::nDll2 := DllLoad( 'USER32.DLL' )

RETURN self

*+
*+
*+    Method DLG8LCD:create()
*+
*+
*+
METHOD DLG8LCD:create()

LOCAL aSize := { 0, 0 }
LOCAL oBMP, aBMP, cRect
LOCAL hWnd, i, iMax, oObj

   IF .NOT. EMPTY( ::cLogo )
      ::oBMP:Loadfile( ::cLogo )
   ELSE
      ::oBMP:Load(, ::nLogo )
   ENDIF

   aSize[ 1 ] := ( ::aDlgSize[ 1 ] * 8 )
   aSize[ 2 ] := ( ::aDlgSize[ 2 ] )

   oBMP := BMP2BMP( ::oBMP, aSize )
   aBMP := BMPsplit( oBMP, ::aDlgSize, 8 )

#IFDEF __XPP__
   AEVAL( ::aAnzeig, { | o, i | o:drawingarea:bitmap := aBMP[ i ] } )
#ENDIF

   ::oH1:create()
   ::oH2:create()

   ::oP1:create()

   ::oM1:create()
   ::oM2:create()

   ::oP2:create()

   ::oS1:create()
   ::oS2:create()

   ::oMenu := ::MakeMenu( ::aAnzeig[ 1 ] )

   AEVAL( ::aAnzeig, { | o | o:show() } )

RETURN self

*+
*+
*+    Method DLG8LCD:Destroy()
*+
*+
*+
METHOD DLG8LCD:Destroy()

   DLLUNLOAD( ::nDll1 )
   DLLUNLOAD( ::nDll2 )

RETURN self

*+
*+
*+    Method DLG8LCD:API_SetRegion()
*+
*+
*+
METHOD DLG8LCD:API_SetRegion( oXbp, aRegion )

LOCAL hRgn, hAdd, nX, hComb, nRet

   IF EMPTY( aRegion )
      RETURN NIL
   ENDIF

   IF ::nDll1 <> 0
      /* Create first region */
      hRgn := DLLCALL( ::nDLL1, DLL_STDCALL, "CreateRectRgn", ;
                       aRegion[ 1, 1 ] * ::nXzoom, ;
                       aRegion[ 1, 2 ] * ::nYzoom, ;
                       aRegion[ 1, 3 ] * ::nXzoom, ;
                       aRegion[ 1, 4 ] * ::nYzoom )

      FOR nX := 2 TO LEN( aRegion )
         /*create all the other regions and combine them with the first*/
         hAdd := DLLCALL( ::nDLL1, DLL_STDCALL, "CreateRectRgn", ;
                          aRegion[ nX, 1 ] * ::nXzoom, ;
                          aRegion[ nX, 2 ] * ::nYzoom, ;
                          aRegion[ nX, 3 ] * ::nXzoom, ;
                          aRegion[ nX, 4 ] * ::nYzoom )

         nRet := DLLCALL( ::nDll1, DLL_STDCALL, "CombineRgn", hRgn, hRgn, hAdd, RGN_OR )

         /*discard this region (no longer needed) */
         DLLCALL( ::nDll1, DLL_STDCALL, "DeleteObject", hAdd )
      NEXT

      /*call windows to create the region */
      DLLCALL( ::nDll2, DLL_STDCALL, "SetWindowRgn", oXbp:GetHwnd(), hRgn, 1 )

   ENDIF

RETURN NIL

*+
*+
*+    Method DLG8LCD:ShowZero()
*+
*+
*+
METHOD DLG8LCD:ShowZero()

LOCAL i, iMax := LEN( ::aAnzeig )
LOCAL aDesk := APPDESKTOP() :CurrentSize()
LOCAL aSize := ACLONE( ::aDlgSize )
LOCAL aPos  := { 0, 0 }
LOCAL oBMP
LOCAL aBMP

   aSize[ 1 ] *= ::nXzoom
   aSize[ 2 ] *= ::nYzoom

   aPos[ 1 ] := 8 + ( aDesk[ 1 ] - ( aSize[ 1 ] * iMax ) ) / 2
   aPos[ 2 ] := 0 + ( aDesk[ 2 ] - ( aSize[ 2 ] ) ) / 2

   FOR i := 1 TO iMax
      ::aAnzeig[ i ] :SetPosAndSize( aPos, aSize )
      ::API_SetRegion( ::aAnzeig[ i ], ::aMask[ 1 ] )
      ::aTime[ i ] := ""

      aPos[ 1 ] += aSize[ 1 ] + 1
   NEXT

   oBMP := BMP2BMP( ::oBMP, { aSize[ 1 ] * 8, aSize[ 2 ] } )
   aBMP := BMPsplit( oBMP, aSize, 8 )
   AEVAL( ::aAnzeig, { | o, i | o:drawingarea:bitmap := aBMP[ i ], o:configure() } )

RETURN self

*+
*+
*+    Method DLG8LCD:ShowTime()
*+
*+
*+
METHOD DLG8LCD:ShowTime()

LOCAL cTime := TIME()
LOCAL i

   FOR i := 1 TO 8
      IF i == 3 .OR. i == 6
         IF SUBSTR( cTime, i, 1 ) == ::aTime[ i ]

         ELSE
            ::aTime[ i ] := SUBSTR( cTime, i, 1 )
            ::API_SetRegion( ::aAnzeig[ i ], ::aMask[ 11 ] )
         ENDIF
      ELSE
         IF SUBSTR( cTime, i, 1 ) == ::aTime[ i ]
         ELSE
            ::aTime[ i ] := SUBSTR( cTime, i, 1 )
            IF( ::aTime[ i ] == "0", ::API_SetRegion( ::aAnzeig[ i ], ::aMask[ 1 ] ), NIL )
            IF( ::aTime[ i ] == "1", ::API_SetRegion( ::aAnzeig[ i ], ::aMask[ 2 ] ), NIL )
            IF( ::aTime[ i ] == "2", ::API_SetRegion( ::aAnzeig[ i ], ::aMask[ 3 ] ), NIL )
            IF( ::aTime[ i ] == "3", ::API_SetRegion( ::aAnzeig[ i ], ::aMask[ 4 ] ), NIL )
            IF( ::aTime[ i ] == "4", ::API_SetRegion( ::aAnzeig[ i ], ::aMask[ 5 ] ), NIL )
            IF( ::aTime[ i ] == "5", ::API_SetRegion( ::aAnzeig[ i ], ::aMask[ 6 ] ), NIL )
            IF( ::aTime[ i ] == "6", ::API_SetRegion( ::aAnzeig[ i ], ::aMask[ 7 ] ), NIL )
            IF( ::aTime[ i ] == "7", ::API_SetRegion( ::aAnzeig[ i ], ::aMask[ 8 ] ), NIL )
            IF( ::aTime[ i ] == "8", ::API_SetRegion( ::aAnzeig[ i ], ::aMask[ 9 ] ), NIL )
            IF( ::aTime[ i ] == "9", ::API_SetRegion( ::aAnzeig[ i ], ::aMask[ 10 ] ), NIL )
         ENDIF
      ENDIF
   NEXT

RETURN NIL

*+
*+
*+    Method DLG8LCD:LoadMask()
*+
*+
*+
METHOD DLG8LCD:LoadMask()

LOCAL aMask := {}
LOCAL aMIA  := ::MaskItemArray()

   AADD( aMask, ::GetMaskArray( aMIA, ::ZahlArray( 0 ) ) )
   AADD( aMask, ::GetMaskArray( aMIA, ::ZahlArray( 1 ) ) )
   AADD( aMask, ::GetMaskArray( aMIA, ::ZahlArray( 2 ) ) )
   AADD( aMask, ::GetMaskArray( aMIA, ::ZahlArray( 3 ) ) )
   AADD( aMask, ::GetMaskArray( aMIA, ::ZahlArray( 4 ) ) )
   AADD( aMask, ::GetMaskArray( aMIA, ::ZahlArray( 5 ) ) )
   AADD( aMask, ::GetMaskArray( aMIA, ::ZahlArray( 6 ) ) )
   AADD( aMask, ::GetMaskArray( aMIA, ::ZahlArray( 7 ) ) )
   AADD( aMask, ::GetMaskArray( aMIA, ::ZahlArray( 8 ) ) )
   AADD( aMask, ::GetMaskArray( aMIA, ::ZahlArray( 9 ) ) )
   AADD( aMask, ::GetMaskArray( aMIA, ::ZahlArray( 10 ) ) )

RETURN aMask

*+
*+
*+    Method DLG8LCD:GetMaskArray()
*+
*+
*+
METHOD DLG8LCD:GetMaskArray( aMIA, aZeig )

LOCAL i, iMax := LEN( aMIA )
LOCAL aRet := {}

   FOR i := 1 TO iMax
      IF ASCAN( aZeig, { | e | e = i } ) > 0
         AADD( aRet, aMIA[ i ] )
      ENDIF
   NEXT

RETURN aRet

*+
*+
*+    Method DLG8LCD:MaskItemArray()
*+
*+
*+
METHOD DLG8LCD:MaskItemArray()

LOCAL aRegion := {}
   // 1
   AADD( aRegion, { 5, 160, 20 + 9, 250 } )                 //      Balken links Oben
   AADD( aRegion, { 5 + 8, 251, 21, 259 } )                 // Nase Balken links Oben   oben
   AADD( aRegion, { 5 + 8, 151, 21, 159 } )                 // Nase Balken links Oben   unten
   // 4
   AADD( aRegion, { 5, 39, 20 + 9, 128 } )                  //      Balken links unten
   AADD( aRegion, { 5 + 8, 129, 21, 137 } )                 // Nase Balken links unten  oben
   AADD( aRegion, { 5 + 8, 30, 21, 38 } )                   // Nase Balken links unten  unten
   // 7
   AADD( aRegion, { 21 + 9, 252, 70 + 9, 280 } )            //      Balken Mitte Oben
   AADD( aRegion, { 21, 260, 29, 272 } )                    // Nase Balken Mitte Oben   links
   AADD( aRegion, { 80, 260, 88, 272 } )                    // Nase Balken Mitte Oben   rechts
   // 10
   AADD( aRegion, { 21 + 9, 130, 70 + 9, 158 } )            //      Balken Mitte Mitte
   AADD( aRegion, { 21, 138, 29, 150 } )                    // Nase Balken Mitte Mitte  links
   AADD( aRegion, { 80, 138, 88, 150 } )                    // Nase Balken Mitte Mitte  rechts
   // 13
   AADD( aRegion, { 21 + 9, 9, 70 + 9, 37 } )               //      Balken Mitte Unten
   AADD( aRegion, { 21, 17, 29, 29 } )                      // Nase Balken Mitte Unten  links
   AADD( aRegion, { 80, 17, 88, 29 } )                      // Nase Balken Mitte Unten  rechts
   // 16
   AADD( aRegion, { 81, 160, 96 + 9, 250 } )                //      Balken Rechts oben
   AADD( aRegion, { 81 + 8, 251, 97, 259 } )                // Nase Balken Rechts oben  oben
   AADD( aRegion, { 81 + 8, 151, 97, 159 } )                // Nase Balken Rechts oben  unten
   // 19
   AADD( aRegion, { 81, 39, 96 + 9, 128 } )                 //      Balken Rechts unten
   AADD( aRegion, { 81 + 8, 129, 97, 137 } )                // Nase Balken Rechts unten oben
   AADD( aRegion, { 81 + 8, 30, 97, 38 } )                  // Nase Balken Rechts unten unten
   // 22
   AADD( aRegion, { 40, 70, 60, 100 } )
   AADD( aRegion, { 40, 200, 60, 230 } )

RETURN aRegion

*+
*+
*+    Method DLG8LCD:ZahlArray()
*+
*+
*+
METHOD DLG8LCD:ZahlArray( nNo )

LOCAL aZeig

   *#IFDEF Use_TOPLEFT
   *   DO CASE
   *      CASE nNo = 0
   *         aZeig := { 1, 2, 3, 4, 5, 6, 7, 8, 9, 13, 14, 15, 16, 17, 18, 19, 20, 21 }
   *      CASE nNo = 1
   *         aZeig := { 16, 17, 18, 19, 20, 21 }
   *      CASE nNo = 2
   *         aZeig := { 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18 }
   *      CASE nNo = 3
   *         aZeig := { 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21 }
   *      CASE nNo = 4
   *         aZeig := { 1, 2, 3, 10, 11, 12, 16, 17, 18, 19, 20, 21 }
   *      CASE nNo = 5
   *         aZeig := { 1, 2, 3, 7, 8, 9, 10, 11, 12, 13, 14, 15, 19, 20, 21 }
   *      CASE nNo = 6
   *         aZeig := { 1, 2, 3, 4, 5, 6, 10, 11, 12, 13, 14, 15, 19, 20, 21 }
   *      CASE nNo = 7
   *         aZeig := { 7, 8, 9, 16, 17, 18, 19, 20, 21 }
   *      CASE nNo = 8
   *         aZeig := { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21 }
   *      CASE nNo = 9
   *         aZeig := { 1, 2, 3, 7, 8, 9, 10, 11, 12, 16, 17, 18, 19, 20, 21 }
   *      CASE nNo = 10
   *         aZeig := { 22, 23 }                                // ":"
   *   ENDCASE
   *#ELSE      // Windows use Topleft as 0,0
   DO CASE
      CASE nNo = 0
         aZeig := { 1, 2, 3, 4, 5, 6, 7, 8, 9, 13, 14, 15, 16, 17, 18, 19, 20, 21 }
      CASE nNo = 1
         aZeig := { 16, 17, 18, 19, 20, 21 }
      CASE nNo = 2
         aZeig := { 1, 2, 3, 7, 8, 9, 10, 11, 12, 13, 14, 15, 19, 20, 21 }
      CASE nNo = 3
         aZeig := { 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21 }
      CASE nNo = 4
         aZeig := { 4, 5, 6, 10, 11, 12, 16, 17, 18, 19, 20, 21 }
      CASE nNo = 5
         aZeig := { 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18 }
      CASE nNo = 6
         aZeig := { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18 }
      CASE nNo = 7
         aZeig := { 13, 14, 15, 16, 17, 18, 19, 20, 21 }
      CASE nNo = 8
         aZeig := { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21 }
      CASE nNo = 9
         aZeig := { 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21 }
      CASE nNo = 10
         aZeig := { 22, 23 }                                // ":"
   ENDCASE
   *#ENDIF

RETURN aZeig

*+
*+
*+    Method DLG8LCD:MakeMenu()
*+
*+
*+
METHOD DLG8LCD:MakeMenu( oParent )

LOCAL oMenu

   oMenu := XBPMENU() :new( oParent )
   oMenu:title := "~Setup"
   oMenu:create()
   oMenu:addItem( { ::MenuZoom( oParent ) } )
   oMenu:addItem( { ::MenuTPZ( oParent ) } )

RETURN oMenu

*+
*+
*+    Method DLG8LCD:MenuZoom()
*+
*+
*+
METHOD DLG8LCD:MenuZoom( oParent )

LOCAL oMenu

   oMenu := XBPMENU() :new( oParent )
   oMenu:title := "~Zoom"
   oMenu:create()

   oMenu:addItem( { "  200 %", { || ::nXzoom := 2.00, ::nYzoom := 2.00, ::ShowZero() } } )
   oMenu:addItem( { "  150 %", { || ::nXzoom := 1.50, ::nYzoom := 1.50, ::ShowZero() } } )
   oMenu:addItem( { "  140 %", { || ::nXzoom := 1.40, ::nYzoom := 1.40, ::ShowZero() } } )
   oMenu:addItem( { "  130 %", { || ::nXzoom := 1.30, ::nYzoom := 1.30, ::ShowZero() } } )
   oMenu:addItem( { "  120 %", { || ::nXzoom := 1.20, ::nYzoom := 1.20, ::ShowZero() } } )
   oMenu:addItem( { "  110 %", { || ::nXzoom := 1.10, ::nYzoom := 1.10, ::ShowZero() } } )
   oMenu:addItem( { "  100 %", { || ::nXzoom := 1.00, ::nYzoom := 1.00, ::ShowZero() } } )
   oMenu:addItem( { "  ~90 %", { || ::nXzoom := 0.90, ::nYzoom := 0.90, ::ShowZero() } } )
   oMenu:addItem( { "  ~80 %", { || ::nXzoom := 0.80, ::nYzoom := 0.80, ::ShowZero() } } )
   oMenu:addItem( { "  ~70 %", { || ::nXzoom := 0.70, ::nYzoom := 0.70, ::ShowZero() } } )
   oMenu:addItem( { "  ~60 %", { || ::nXzoom := 0.60, ::nYzoom := 0.60, ::ShowZero() } } )
   oMenu:addItem( { "  ~50 %", { || ::nXzoom := 0.50, ::nYzoom := 0.50, ::ShowZero() } } )
   oMenu:addItem( { "  ~40 %", { || ::nXzoom := 0.40, ::nYzoom := 0.40, ::ShowZero() } } )
   oMenu:addItem( { "  ~30 %", { || ::nXzoom := 0.30, ::nYzoom := 0.30, ::ShowZero() } } )
   oMenu:addItem( { "  ~20 %", { || ::nXzoom := 0.20, ::nYzoom := 0.20, ::ShowZero() } } )
   oMenu:addItem( { "  ~10 %", { || ::nXzoom := 0.10, ::nYzoom := 0.10, ::ShowZero() } } )

RETURN oMenu

*+
*+
*+    Method DLG8LCD:MenuTPZ()
*+
*+
*+
METHOD DLG8LCD:MenuTPZ( oParent )

LOCAL oSubMenu

   oSubMenu := XBPMENU() :new( oParent )
   oSubMenu:title := "~Transparenz"
   oSubMenu:create()

   oSubMenu:addItem( { "  ~0 %", { || ::SetTPZ( 0 ) },, } )
   oSubMenu:addItem( { " ~10 %", { || ::SetTPZ( 10 ) },, } )
   oSubMenu:addItem( { " ~20 %", { || ::SetTPZ( 20 ) },, } )
   oSubMenu:addItem( { " ~30 %", { || ::SetTPZ( 30 ) },, } )
   oSubMenu:addItem( { " ~40 %", { || ::SetTPZ( 40 ) },, } )
   oSubMenu:addItem( { " ~50 %", { || ::SetTPZ( 50 ) },, } )
   oSubMenu:addItem( { " ~60 %", { || ::SetTPZ( 60 ) },, } )
   oSubMenu:addItem( { " ~70 %", { || ::SetTPZ( 70 ) },, } )
   oSubMenu:addItem( { " ~80 %", { || ::SetTPZ( 80 ) },, } )
   oSubMenu:addItem( { " ~90 %", { || ::SetTPZ( 90 ) },, } )

RETURN oSubMenu

*+
*+
*+    Method DLG8LCD:SetTPZ()
*+
*+
*+
METHOD DLG8LCD:SetTPZ( nTransparency )

LOCAL hWnd

   AEVAL( ::aAnzeig, { | o | hWnd := o:getHWND(), ;
                       o:hide(), ;
                       SetWindowLayered( hWnd, .T. ), ;     // Stil setzen
                       SetWindowTransparency( hWnd, 100 ), ;                                                            // unsichtbar machen
                       o:Show(), ;                          // Fenster anzeigen
                       SetWindowTransparency( hWnd, 100, nTransparency ) } )                                            // sichtbar machen
RETURN NIL

* -------------------------------------------------------------------------- *

*+
*+
*+    Class ResourceAsBmp
*+
*+
*+
CLASS ResourceAsBmp FROM XbpBitmap

   EXPORTED:
      METHOD Load()

ENDCLASS

*+
*+
*+    Method ResourceAsBmp:Load()
*+
*+
*+
METHOD ResourceAsBmp:Load( cDll, nID, cType )               // BMP, JPG, PNG, GIF

LOCAL xResource

   DEFAULT cDll TO APPNAME()

   IF EMPTY( cType )
      ::XbpBitmap:load( cDll, nID )
   ELSE
#IFDEF __XPP__
      xResource := LoadResource( nID, cDll, cType )
#ENDIF
      ::setBuffer( xResource )
   ENDIF
RETURN .T.

* --------------------------- Bitmap --------------------------------------- *

*+
*+
*+    Static Function BMP2BMP()
*+
*+    Called from ( dlg8lcd.prg  )   1 - method dlg8lcd:create()
*+                                   1 - method dlg8lcd:showzero()
*+
*+
*+
STATIC FUNCTION BMP2BMP( oBMP, aXbpSize )

LOCAL oHuge
LOCAL oTiny
LOCAL oPS
LOCAL oRet
LOCAL nBits
LOCAL nPlanes

   IF aXbpSize[ 2 ] > 0
      oHuge := oBMP
      nBits := oBMP:bits
      nPlanes := oBMP:planes

      // Create new bitmap with given size
      oPS := XBPPRESSPACE() :new() :Create()
      oTiny := XBPBITMAP() :New() :Create()
      oTiny:Make( aXbpSize[ 1 ], aXbpSize[ 2 ], nPlanes, nBits )
      oTiny:presSpace( oPS )

      // Copy and resize the Source bitmap to the new Target bitmap
      oHuge:Draw( oPS, { 0, 0, aXbpSize[ 1 ], aXbpSize[ 2 ] },,, GRA_BLT_BBO_IGNORE )
      oRet := oTiny
   ELSE
      oRet := oBMP
   ENDIF

RETURN oRet

*+
*+
*+    Static Function BMPsplit()
*+
*+    Called from ( dlg8lcd.prg  )   1 - method dlg8lcd:create()
*+                                   1 - method dlg8lcd:showzero()
*+
*+
*+
STATIC FUNCTION BMPsplit( oBMP, aXbpSize, nAnzahl, lSave )

LOCAL oHuge
LOCAL oTiny
LOCAL oPS
LOCAL oRet
LOCAL nBits
LOCAL nPlanes
LOCAL aBMP    := {}
LOCAL nSizeX
LOCAL nSizeY
LOCAL nSteps, i

   DEFAULT lSave TO .F.

   IF aXbpSize[ 2 ] > 0
      oHuge := oBMP
      nBits := oBMP:bits
      nPlanes := oBMP:planes

      nSizeX := oBMP:xSize
      nSizeY := oBMP:ySize
      nSteps := INT( nSizeX / nAnzahl )

      FOR i := 1 TO nAnzahl
         oTiny := XBPBITMAP() :New() :Create()
         oTiny:Make( aXbpSize[ 1 ], aXbpSize[ 2 ], nPlanes, nBits )
         oPS := XBPPRESSPACE() :new()
         oTiny:presSpace( oPS )

         oHuge:Draw( oPS, { 0, 0, aXbpSize[ 1 ], aXbpSize[ 2 ] }, ;
                            { nSteps * ( i - 1 ), 0, nSteps * ( i ), nSizeY }, ;
                            ,, GRA_BLT_BBO_IGNORE )

         AADD( aBMP, oTiny )

         IF lSave
            oTiny:saveFile( "TEST" + STRZERO( i, 2 ) + ".JPG", XBPBMP_FORMAT_JPG )
         ENDIF
*         Sleep( 1 )
         oPS := NIL
      NEXT
   ENDIF

RETURN aBMP

* --------------------------- moving Win ----------------------------------- *

*+
*+
*+    Static Function MoveNow()
*+
*+    Called from ( dlg8lcd.prg  )   1 - procedure main()
*+
*+
*+
STATIC FUNCTION MoveNow( oDlg )

LOCAL nEvent, mp1, mp2, oXbp
LOCAL aPos   := GetCursorPos( .T. )

   oDlg:CaptureMouse( .T. )

   nEvent := xbe_None
   DO WHILE .T.
      nEvent := APPEVENT( @mp1, @mp2, @oXbp )
      DO CASE
         CASE nEvent == xbeP_Keyboard .AND. mp1 == xbeK_ESC
            EXIT

         CASE nEvent == xbeM_Motion
            MoveWin( GetCursorPos( .T. ), @aPos, oDlg )

         CASE nEvent == xbeM_LbUp
            EXIT

      ENDCASE
      oXbp:HandleEvent( nEvent, mp1, mp2 )
   ENDDO

   oDlg:CaptureMouse( .F. )

RETURN NIL

*+
*+
*+    Static Function MoveWin()
*+
*+    Called from ( dlg8lcd.prg  )   1 - static function movenow()
*+
*+
*+
STATIC FUNCTION MoveWin( aPosNew, aLBDownAtPos, oDlg )

LOCAL aRefSize := { nil, nil }
LOCAL aPos     := { nil, nil }
LOCAL nR       := APPDESKTOP() :currentSize() [1]
LOCAL nB       := APPDESKTOP() :currentSize() [2]
LOCAL nPx
LOCAL nPy

   // Get Mouse Movement differentials
   //
   nPx := aPosNew[ 1 ] - aLBDownAtPos[ 1 ]
   nPy := aPosNew[ 2 ] - aLBDownAtPos[ 2 ]

   // Set 'Left Button Down At' to new position
   //
   aLBDownAtPos[ 1 ] := aPosNew[ 1 ]
   aLBDownAtPos[ 2 ] := aPosNew[ 2 ]

   // Only process if there is a difference
   //
   IF ABS( nPx ) > 0 .OR. ABS( nPy ) > 0

      // Get the Dialog current absolute position and size (Top Left 0,0)
      //
      GetaPosAndSize( oDlg, @aPos, @aRefSize )

      // Establish boundaries to confine the dialog to screen area
      //
      nR -= aRefSize[ 1 ]
      nB -= aRefSize[ 2 ]

      // Add cursor movement differentials
      //
      aPos[ 1 ] += nPx
      aPos[ 2 ] += nPy

      // Check Boundaries  -  Nothing to go off-screen
      //
      aPos[ 1 ] := INT( IIF( aPos[ 1 ] < 0, 0, aPos[ 1 ] ) )       // Left check
      * aPos[ 1 ] := INT( IIF( aPos[ 1 ] > nR, nR, aPos[ 1 ] ) )   // Right check - not used with 2nd Monitor
      aPos[ 2 ] := INT( IIF( aPos[ 2 ] < 0, 0, aPos[ 2 ] ) )       // Top Check
      * aPos[ 2 ] := INT( IIF( aPos[ 2 ] > nB, nB, aPos[ 2 ] ) )   // Bottom Check - not used with 2nd Monitor
      SETAPPFOCUS( oDlg )

      // Move the Dialog to match mouse movement differentials
      //
      DllCall( "User32.DLL", DLL_STDCALL, "MoveWindow", oDlg:getHWND(), ;
               aPos[ 1 ], aPos[ 2 ], aRefSize[ 1 ], aRefSize[ 2 ], 1 )

   ENDIF
RETURN NIL

* --------------------------- Cursor Position ------------------------------ *

*+
*+
*+    Static Function GetCursorPos()
*+
*+    Called from ( dlg8lcd.prg  )   2 - static function movenow()
*+                                   1 - static function popabspos()
*+
*+
*+
STATIC FUNCTION GetCursorPos( lTopDown )

LOCAL sPoint := REPLICATE( CHR( 0 ), 8 )
LOCAL nX     := 0
LOCAL nY     := 0

STATIC GetCursorPos

   DEFAULT lTopDown TO .F.

   IF GetCursorPos = NIL
      GetCursorPos := DllPrepareCall( "USER32.DLL", DLL_STDCALL, "GetCursorPos" )
   ENDIF

   DllExecuteCall( GetCursorPos, @sPoint )

   nX := BIN2L( SUBSTR( sPoint, 1, 4 ) )
   nY := BIN2L( SUBSTR( sPoint, 5, 4 ) )

   IF .NOT. lTopDown
      nY := ( - 1 * nY ) + APPDESKTOP() :CURRENTSIZE() [2] - 1
   ENDIF

RETURN ( { nX, nY } )

*+
*+
*+    Static Function GetaPosAndSize()
*+
*+    Called from ( dlg8lcd.prg  )   1 - static function movewin()
*+
*+
*+
STATIC FUNCTION GetaPosAndSize( obj, aPos, aRefSize )

LOCAL nLeft   := 0
LOCAL nTop    := 0                                          // aPos == aRefSize == {nil,nil}
LOCAL nRight  := 0                                          // passed by reference
LOCAL nBottom := 0
LOCAL cBuffer := SPACE( 16 )

   // Get the absolute position and size of the Object (relative to DeskTop)
   //
   DllCall( "User32.DLL", DLL_STDCALL, "GetWindowRect", obj:GetHWND(), @cBuffer )

   nLeft   := Bin2U( SUBSTR( cBuffer, 1, 4 ) )
   nTop    := Bin2U( SUBSTR( cBuffer, 5, 4 ) )
   nRight  := Bin2U( SUBSTR( cBuffer, 9, 4 ) )
   nBottom := Bin2U( SUBSTR( cBuffer, 13, 4 ) )

   aRefSize[ 1 ] := nRight - nLeft
   aRefSize[ 2 ] := nBottom - nTop
   aPos[ 1 ] := nLeft
   aPos[ 2 ] := nTop

RETURN aPos

*+
*+
*+    Static Function PopAbsPos()
*+
*+    Called from ( dlg8lcd.prg  )   1 - procedure main()
*+
*+
*+
STATIC FUNCTION PopAbsPos( oMainDlg )

LOCAL aPos := { 0, 0 }
LOCAL aDlg := oMainDlg:currentpos()
LOCAL aAbs := GetCursorPos()

   aPos[ 1 ] := aAbs[ 1 ] - aDlg[ 1 ]
   aPos[ 2 ] := aAbs[ 2 ] - aDlg[ 2 ]

RETURN aPos

* --------------------------- Transparency --------------------------------- *

*+
*+
*+    Function SetWindowLayered()
*+
*+    Called from ( dlg8lcd.prg  )   1 - method dlg8lcd:create()
*+                                   1 - method dlg8lcd:settpz()
*+
*+
*+
FUNCTION SetWindowLayered( hWnd, lActive )

LOCAL lExStyle := GetWindowLongA( hWnd, GWL_EXSTYLE )
   SetDefault( lActive, .T. )
   IF lActive
      IF !( lExStyle $ WS_EX_LAYERED )
         lExStyle := lExStyle + WS_EX_LAYERED
         SetWindowLongA( hWnd, GWL_EXSTYLE, lExStyle )
      ENDIF
   ELSE
      IF ( lExStyle $ WS_EX_LAYERED )
         lExStyle -= WS_EX_LAYERED
         SetWindowLongA( hWnd, GWL_EXSTYLE, lExStyle )
      ENDIF
   ENDIF
RETURN ( NIL )

*+
*+
*+    Function SetWindowTransparency()
*+
*+    Called from ( dlg8lcd.prg  )   2 - method dlg8lcd:create()
*+                                   2 - method dlg8lcd:settpz()
*+
*+
*+
FUNCTION SetWindowTransparency( hWnd, nPercent, nToPercent, nSpeed )

LOCAL nTransparentValue
LOCAL nIx
LOCAL nStep
   SetDefault( nPercent, 50 )
   SetDefault( nToPercent, nPercent )
   SetDefault( nSpeed, 1 )
   IIF( nToPercent < nPercent, nStep := - 1 * nSpeed, nStep := 1 * nSpeed )
   FOR nIx := nPercent TO nToPercent STEP nStep
      nTransparentValue := ( 1 - nIx / 100 ) * 255
      SetLayeredWindowAttributes( hWnd, GraMakeRGBColor( 0, 255, 0 ), nTransparentValue, LWA_ALPHA )
   NEXT nIx
   nTransparentValue := ( 1 - nToPercent / 100 ) * 255
   SetLayeredWindowAttributes( hWnd, GraMakeRGBColor( 0, 255, 0 ), nTransparentValue, LWA_ALPHA )
RETURN ( NIL )

*+
*+
*+    Function GetWindowLongA()
*+
*+    Called from ( dlg8lcd.prg  )   1 - function setwindowlayered()
*+
*+
*+
FUNCTION GetWindowLongA( nHwnd, nIndex )

LOCAL nDll := DllLoad( "USER32.DLL" )
LOCAL xRet
   IF nDll != 0
      xRet := DllCall( nDll, DLL_STDCALL, "GetWindowLongA", nHwnd, nIndex )
      DllUnload( nDll )
   ENDIF
RETURN xRet

*+
*+
*+    Function SetWindowLongA()
*+
*+    Called from ( dlg8lcd.prg  )   2 - function setwindowlayered()
*+
*+
*+
FUNCTION SetWindowLongA( nHwnd, nIndex, nNewIndex )

LOCAL nDll := DllLoad( "USER32.DLL" )
LOCAL xRet
   IF nDll != 0
      xRet := DllCall( nDll, DLL_STDCALL, "SetWindowLongA", nHwnd, nIndex, nNewIndex )
      DllUnload( nDll )
   ENDIF
RETURN xRet

*+
*+
*+    Function SetLayeredWindowAttributes()
*+
*+    Called from ( dlg8lcd.prg  )   2 - function setwindowtransparency()
*+
*+
*+
FUNCTION SetLayeredWindowAttributes( hWnd, crKey, bAlpha, dwFlags )

LOCAL nDll := DllLoad( "USER32.DLL" )
LOCAL xRet
   IF nDll != 0
      xRet := DllCall( nDll, DLL_STDCALL, "SetLayeredWindowAttributes", hWnd, crKey, bAlpha, dwFlags )
      DllUnload( nDll )
   ENDIF
RETURN xRet

/**************************** harbour ************************************/

#IFDEF __XPP__
#ELSE
PROCEDURE SetDefault(var, def)
   DEFAULT (var) TO (def)
RETURN

*STATIC FUNCTION AppDeskTop()
*   LOCAL oDeskTop := WvgWindow():New()
*
*   oDeskTop:hWnd := Win_GetDesktopWindow()
*   #if 0
*   oDeskTop:hWnd := HB_INLINE(){
*      hb_retnint( ( LONG ) GetDesktopWindow() );
*   }
*   #endif
*RETURN oDeskTop

STATIC FUNCTION AppName( lWithPath )
   LOCAL n
   LOCAL cName := hb_argV( 0 )
   //
   DEFAULT lWithPath TO .f.
   //
   IF !( lWithPath )
      IF ( n := rat( '\', cName ) ) > 0
         cName := substr( cName, n+1 )
      ENDIF
   ENDIF
   //
RETURN  cName

STATIC FUNCTION SetAppWindow( oWnd )
   LOCAL aWnd
   STATIC sWnd
   aWnd := sWnd
   IF hb_isObject( oWnd )
      sWnd := oWnd
   ENDIF
RETURN aWnd

STATIC FUNCTION SetAppFocus( oWnd )
   LOCAL aWnd
   STATIC sWnd
   aWnd := sWnd
   IF hb_isObject( oWnd )
      sWnd := oWnd
   ENDIF
RETURN aWnd

STATIC FUNCTION MsgBox( cMessage, cTitle )
*  RETURN Win_MessageBox( , cMessage, cTitle )
RETURN WVG_MessageBox( , cMessage, cTitle )

STATIC FUNCTION SETTIMEREVENT(nTime, bBlock)
DEFAULT nTime TO 1

   DO WHILE .T.
      IF nTime = 0
         EXIT
      ENDIF
      IF Inkey (nTime/100) == K_ESC
         EXIT
      ENDIF
      hb_threadStart( bBlock )
   ENDDO

RETURN NIL

#ENDIF

*
*+ EOF: DLG8LCD.PRG
*